package de.snailshell.consensus.demo.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.snailshell.consensus.demo.Constants;
import de.uka.ipd.consensus.foundation.ontology.OntologyManager;
import de.uka.ipd.consensus.foundation.schema.Topic;
import de.uka.ipd.consensus.foundation.schema.User;

/**
 * @author Thomas Much
 * @version 2006-06-14
 */
public class TopicFromParamIdToRequestAction extends BasisAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		if (!isUserLoggedOn(request)) {
			return mapping.findForward( Constants.MAPPING_FAILURE );			
		}
		
		String id = request.getParameter( "id" );
		
		if ((id != null) && (id.length() > 0)) {

			OntologyManager om = this.getOntologyManager();
			
			User user = this.getUser( request );
			
			Topic t = om.getQueryEngine().getTopicById( user, id );
			
			request.setAttribute( Constants.REQUEST_ATTR_TOPIC, t );
		}

		return mapping.findForward( Constants.MAPPING_SUCCESS );
	}
}
